<?php
/* ExMail
    name: Ext Mail(PHPMailer)
	OneThird CMS coyright(c) team1/3 All Rights Reserved.
*/

/**
 * PHPMailer - PHP email creation and transport class.
 * PHP Version 5.5.
 *
 * @see https://github.com/PHPMailer/PHPMailer/ The PHPMailer GitHub project
 *
 * @author    Marcus Bointon (Synchro/coolbru) <phpmailer@synchromedia.co.uk>
 * @author    Jim Jagielski (jimjag) <jimjag@gmail.com>
 * @author    Andy Prevost (codeworxtech) <codeworxtech@users.sourceforge.net>
 * @author    Brent R. Matzelle (original founder)
 * @copyright 2012 - 2019 Marcus Bointon
 * @copyright 2010 - 2012 Jim Jagielski
 * @copyright 2004 - 2009 Andy Prevost
 * @license   http://www.gnu.org/copyleft/lesser.html GNU Lesser General Public License
 * @note      This program is distributed in the hope that it will be useful - WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 */

	global $config,$tax_rate,$ut,$params,$html;
	if (!isset($config)) { die(); }
	
	use PHPMailer\PHPMailer\PHPMailer;
	use PHPMailer\PHPMailer\Exception;
	
	$params['sx_send_mail']='ex_mail_sender';
	$html['article'][] = exmail_renderer();


function ex_mail_sender( &$mail_ar )
{

	global $params, $database, $config, $p_circle;
	
	$m = get_circle_meta('system_menus');
	if (!isset($m['ExMail_Manager'])) {
		return false;
	}
	$url = $m['ExMail_Manager']['url'];
	$id = $m['ExMail_Manager']['id'];
	unset($params['mail_error']);

	require (dirname(__FILE__).'/ExMail/PHPMailer.php');
	require (dirname(__FILE__).'/ExMail/SMTP.php');
	require (dirname(__FILE__).'/ExMail/Exception.php');
	require (dirname(__FILE__).'/ExMail/OAuth.php');
	require (dirname(__FILE__).'/ExMail/phpmailer.lang-ja.php');

	//SMTPの設定
	$mailer = new PHPMailer();//インスタンス生成
	$mailer->IsSMTP();//SMTPを作成


	if (!read_pagedata($id, $page_ar)) {
		return false;
	}

	if (empty($page_ar['meta']['plugin_embed']['Host'])
	  || empty($page_ar['meta']['plugin_embed']['Username'])
	  || empty($page_ar['meta']['plugin_embed']['Password'] ) ) 
	{
		return false;
	}

	$mailer->Host = $page_ar['meta']['plugin_embed']['Host'];
	$mailer->Username = $page_ar['meta']['plugin_embed']['Username']; // 
	$mailer->Password = $page_ar['meta']['plugin_embed']['Password']; 

	if (is_numeric($page_ar['meta']['plugin_embed']['PORT'])) {
		$mailer->Port = 587;
	} else {
		$mailer->Port = (int)$page_ar['meta']['plugin_embed']['PORT'];
	}
	$page_ar['meta']['plugin_embed']['PORT'] = $page_ar['meta']['plugin_embed']['PORT'];
	
	if (!empty($page_ar['meta']['plugin_embed']['SMTPAuth'])) {
		if ($page_ar['meta']['plugin_embed']['SMTPAuth'] === 'true') {
			$mailer->SMTPAuth = true;
		}
	}
	
	$mailer->SMTPAutoTLS = false;
	if (!empty($page_ar['meta']['plugin_embed']['SMTPAutoTLS'])) {
		if ($page_ar['meta']['plugin_embed']['SMTPAutoTLS']==='true') {
			$mailer->SMTPAutoTLS = true;
		}
	}

	if (!empty($page_ar['meta']['plugin_embed']['SMTPSecure']) && $page_ar['meta']['plugin_embed']['SMTPSecure']!='none') {
		$mailer->SMTPSecure = $page_ar['meta']['plugin_embed']['SMTPSecure'];
	} else {
	}

	$mailer->CharSet = 'utf-8';
	//$mailer->Username = '';
	//$mailer->SMTPDebug = 2; //for debug

	$log_mess='';
	$msg = '';
	if ( isset($mail_ar['message']) ) {
		$log_mess = adjust_mstring($mail_ar['message'],200);
	}
	if (!isset($mail_ar['no-log'])) {
		$log_id = add_actionlog($log_mess);
		if (!$log_id) {
			return false;
		}
	}

	if (!isset($mail_ar['to']) || !isset($mail_ar['message'])) {
		return false;
	}

	$sendto = $mail_ar['to'];
	if (isset($mail_ar['subject'])) {
		$subject = $mail_ar['subject'];
	} else {
		$subject = 'OneThird CMS';
	}
	if (isset($mail_ar['from'])) {
		$sendfrom = $mail_ar['from'];
	} else {
		$sendfrom = $config['site']['email'];
	}

	$msg .= $mail_ar['message']."\r\n";

	if (USE_EMAIL) {

		$mailer->From     = $sendto;
		if (!empty($mail_ar['user_nickname'])) {
			$mailer->FromName = mb_convert_encoding($mail_ar['user_nickname'],"UTF-8","AUTO");
		}
		$mailer->Subject  = mb_convert_encoding($subject,"UTF-8","AUTO");
		$mailer->Body     = mb_convert_encoding($msg,"UTF-8","AUTO");
		$mailer->AddAddress($sendto);
		if (!empty($mail_ar['cc'])) {
			$mailer->AddCC($mail_ar['cc']); 
		}
		if (!empty($mail_ar['bcc'])) {
			$mailer->AddBCC($mail_ar['bcc']); 
		}

		if ($mailer->Send()) {
			$m = "[Send mail] [to:$sendto] [from:$sendfrom] {$log_mess}";
			if (!isset($mail_ar['no-log'])) {
				$database->sql_update("update ".DBX."action_log set data=? where id=?", adjust_mstring($m,250),$log_id );
			}
		} else {
			$m = "[Send mail] [ERROR] [to:$sendto] [from:$sendfrom] {$log_mess}";
			if (!isset($mail_ar['no-log'])) {
				$database->sql_update("update ".DBX."action_log set data=? where id=?", adjust_mstring($m,250),$log_id );
			}
			$params['mail_error'] = $mailer->ErrorInfo;
			return false;
		}
		/*if (isset($mail_ar['cc'])) {
			if (mail($mail_ar['cc'], $subject." (cc:{$sendto})", $msg, $headers)){
			}
		}*/
	} else {
		$m = "[Send mail] [DUMMY] [to:$sendto] [from:$sendfrom] {$log_mess}";
		if (!isset($mail_ar['no-log'])) {
			$database->sql_update("update ".DBX."action_log set data=? where id=?", adjust_mstring($m,250),$log_id );
		}
	}
	return true;
}


function exmail_page( &$page_ar )
{
	global $html,$params,$config,$ut;
	
	if ($page_ar['block_type']==10) {
		if (check_rights('admin')) {
			//snippet_breadcrumb($page_ar['link'], "ショッピングカート管理");
			$params['breadcrumb'] = array();
			$params['breadcrumb'][] = array( 'link'=>'', 'text'=>"<a href='{$ut->link($params['page']['link'],"&:mode=order")}'>ショッピングカート管理</a>" );
			$params['breadcrumb'][] = array( 'link'=>'', 'text'=>"item" );
			return cart_ctrl_item($page_ar);
		}
		return 'rights error';
	}

$html['css']['cart'] = <<<EOT
	<style>
	</style>
EOT;

	snippet_breadcrumb($page_ar['link'], $page_ar['title']);

	$buff = '';


	if (empty($page_ar['meta']['plugin_embed']['PORT'])) {
		$page_ar['meta']['plugin_embed']['PORT']=587;
	}
	if (empty($page_ar['meta']['plugin_embed']['SMTPAuth'])) {
		$page_ar['meta']['plugin_embed']['SMTPAuth']='true';
	}
	if (empty($page_ar['meta']['plugin_embed']['SMTPAutoTLS'])) {
		$page_ar['meta']['plugin_embed']['SMTPAutoTLS']='false';
	}
	if (empty($page_ar['meta']['plugin_embed']['SMTPSecure'])) {
		$page_ar['meta']['plugin_embed']['SMTPSecure']='none';
	}

	$p='plugin_proc';
$buff.= <<<EOT
	{$p('embed','start')}
	<p>Host</p>
	<p>{$p('embed','text','name:Host')}</p>
	<p>Username</p>
	<p>{$p('embed','text','name:Username')}</p>
	<p>Password</p>
	<p>{$p('embed','pass','name:Password')}</p>

	<p>Send Port</p>
	<p>{$p('embed','text','name:PORT')}</p>

	<p>SMTPAuth</p>
	<p>{$p('embed','select','name:SMTPAuth',array('true','false','none'))}</p>

	<p>SMTPSecure</p>
	<p>{$p('embed','select','name:SMTPSecure',array('true','false','none'))}</p>

	<p>SMTPAutoTLS</p>
	<p>{$p('embed','select','name:SMTPAutoTLS',array('true','false','none'))}</p>
	<p>
	{$p('embed','save')}
	</p>


EOT;

	if (check_rights('admin')) {
	}
	
	//$buff .= cart_user_page($page_ar);

	return $buff;
}


function exmail_renderer()
{
	global $params, $ut, $html, $config;

	if (!isset($html['css']['exmail_renderer'])) {
$html['css']['exmail_renderer'] = <<<EOT
		<style>
			.exmail-alert {
				padding:10px;
				margin-bottom:20px;
				background-color: #FFFBCD;
			}
			.exmail-ctrl {
				text-align: right;
			}
			.exmail-info  {
				background-image: url({$config['site_url']}img/lock.png);
				background-size:contain;
				background-repeat:no-repeat;
				background-position: right;
				height:1em;
			}
		</style>
EOT;
	}

	$buff = '';
	$url = '';
	$m = get_circle_meta('system_menus');
	if (empty($m['ExMail_Manager'])) {

$buff = <<<EOT
		<p style='background-color: #ff0000;padding: 20px; color:#FFFFFF; margin: 5px 0;'>
			{$ut->icon('caution')} Error in ExMail Plugin, Please reinstall.
		</p>
EOT;
		return $buff;
	}
	$url = $m['ExMail_Manager']['url'];
	$id = $m['ExMail_Manager']['id'];
	if (read_pagedata($id, $page_ar2)) {
		if (!empty($page_ar2['meta']['plugin_embed']['Host'])
		  && !empty($page_ar2['meta']['plugin_embed']['Username'])
		  && !empty($page_ar2['meta']['plugin_embed']['Password'] ) ) 
		{
			if (check_rights('edit') && empty($page_ar2['meta']['contact_form']['adr_page'])) {
$buff .= <<<EOT
				<div  class='exmail-ctrl'>
					<a href='{$url}'>{$ut->icon('system')} ExMail (PHPMailer) </a>
				</div>
EOT;
				$buff = frame_renderer($buff);
				return $buff;
			}
		}
	}


	if (check_rights('edit')) {
$buff .= <<<EOT
		<p style='background-color: #eb9999;padding: 20px;'>
			{$ut->icon('caution')} ExMail (PHPMailer) needs <a href='{$url}'>settings</a>.
			<div class="edit_pointer ">
EOT;
				$buff .= std_blockmenu_renderer($page_ar2);
$buff .= <<<EOT
			</div>
		</p>
EOT;
		$buff = frame_renderer($buff);
	}

	return $buff;

}


?>